"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.isPriorToFiber = exports.isValidFiberElement = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.number.constructor");

require("core-js/modules/es6.regexp.split");

var _react = _interopRequireDefault(require("react"));

var _flattenDeep = _interopRequireDefault(require("lodash/flattenDeep"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// return true if the element is renderable with react fiber
var isValidFiberElement = function isValidFiberElement(element) {
  return typeof element === 'string' || typeof element === 'number' || _react.default.isValidElement(element);
};

exports.isValidFiberElement = isValidFiberElement;

var isPriorToFiber = function isPriorToFiber(version) {
  var _version$split = version.split('.'),
      _version$split2 = _slicedToArray(_version$split, 1),
      majorVersion = _version$split2[0];

  return Number(majorVersion) < 16;
}; // accepts an element and return true if renderable else return false


exports.isPriorToFiber = isPriorToFiber;

var isReactRenderable = function isReactRenderable(element) {
  // storybook is running with a version prior to fiber,
  // run a simple check on the element
  if (isPriorToFiber(_react.default.version)) {
    return _react.default.isValidElement(element);
  } // the element is not an array, check if its a fiber renderable element


  if (!Array.isArray(element)) {
    return isValidFiberElement(element);
  } // the element is in fact a list of elements (array),
  // loop on its elements to see if its ok to render them


  var elementsList = element.map(isReactRenderable); // flatten the list of elements (possibly deep nested)

  var flatList = (0, _flattenDeep.default)(elementsList); // keep only invalid elements

  var invalidElements = flatList.filter(function (elementIsRenderable) {
    return elementIsRenderable === false;
  }); // it's ok to render this list if there is no invalid elements inside

  return !invalidElements.length;
};

var _default = isReactRenderable;
exports.default = _default;